# -*- coding: utf-8 -*-
"""
[k2_10_test.py]
@author: kenken
"""
from sklearn.ensemble import RandomForestClassifier
####from sklearn.svm import SVC
from sklearn.model_selection import train_test_split
#from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
#import numpy as np
import pandas as pd
# 表示範囲の設定
pd.options.display.max_rows = 100# 60--->100　にした
pd.set_option('display.expand_frame_repr', False)# 全ての列を折りかえさずに表示するために入れた
# 機械学習データを読込み
df=pd.read_pickle('k2_09.pkl')
#df=pd.read_pickle('fx_data_target.pkl')
#------------------------------------------
print(df[0:20])
#
"""
DataFrame　の列
s_sl,m_sl,l_sl,bl_5,bl_0,_4,_3,_2,_1,_0,_h3,_l3,_h2,_l2,_h1,_l1,p_by,p_sl
"""
#　トレーニングデータとテストデータに分離する
#　何種類かを試してみる
"""
#### 「買いＩＮ」用には特徴量（説明変数）の再調整が必要！！
X_train,X_test,y_train,y_test=train_test_split(df[['s_sl','m_sl','l_sl','bl_5','bl_0',
    '_4','_3','_2','_1','_0',
　　　'_h3','_l3','_h2','_l2','_h1','_l1']],df['p_sl'],test_size=0.1,shuffle=False,stratify=None)
"""
### 「売りＩＮ」用に特徴量（説明変数）を設定している
X_train,X_test,y_train,y_test=train_test_split(df[['s_sl','m_sl','l_sl','bl_5','bl_0',
    '_4','_3','_2','_1','_0',
    '_h3','_l3','_h2','_l2','_h1','_l1']],df['p_sl'],test_size=0.2,shuffle=False,stratify=None)
"""
時系列データを扱う場合は、「shuffle=False,stratify=None」をセットで指定する事！
stratifyは「層化抽出法」のこと
"""

print("X_train[0:20]\n\t",X_train[0:20])
print("--------------")
print("y_train[0:20]\n\t",y_train[0:20])
print("-----------------------------")
print("X_test[0:20]\n\t",X_test[0:20])
print("--------------")
print("y_test[:]\n",y_test[0:20])
print("-----------------------------")
##print("y_test.count(1)= ",y_test[:].count(1))
print("len(df)= ",len(df))
print("df['p_sl'].value_counts()\n\t",df['p_sl'].value_counts())
print("df['p_by'].value_counts()\n\t",df['p_by'].value_counts())
print("-----------  ----------  -----------")
#print(y_test[].value_counts())
##########
#　モデルのインスタンスｗｐ生成
clf=RandomForestClassifier(n_estimators=150)
#clf=SVC()
#　fit　学習
clf.fit(X_train,y_train)
#　predict　予測
y_pred=clf.predict(X_test)
#
print("******予測結果******")
print(y_pred[:])
##print("y_test.count(1)= ",y_test.count(1))
#print("y_pred.count(1)= ",y_pred.count(1))
#print("")
#　正解率の計算
#　方法１
print("正解率；計算方法１では、{:.3f}　です。 ".format(accuracy_score(y_test, y_pred)))
print("----------------------------")
#　方法２
#print("正解率；計算方法２では、{:.3f}　です。 ".format(np.mean(y_pred==y_test)))
# 正解と予測値をDataFrameにまとめる
# 予測データと正解データの比較
result = pd.DataFrame({"true":y_test,"pred":y_pred})
## ランダムのindex　を「0」からに直す
result=result.reset_index()
print(result[0:20])
print("----------------------")
#
print("result['pred'].value_counts()\n\t",result['pred'].value_counts())
print("result['true'].value_counts()\n\t",result['true'].value_counts())
#print("len(df)= ",len(df))
print("len(result)= ",len(result))

count_=0
for true_ in result['true']:
    #print("true:",true_)
    if true_==1:
        count_=count_+1
    else:
        pass
#
print("true_==1 の数は、",count_)
########----------------#########
print("-----------------------")
count_OK=0
count_NG=0
for pred_,true_ in zip(result['pred'],result['true']):
    #print("true:",true_)
   #if pred_==-1 and true_==-1:
    if pred_==1 and true_==1:
        count_OK=count_OK+1
    elif pred_==1 and true_!=1:
        count_NG=count_NG+1
    else:
        pass
#print("[pred=-1 and true=-1] の数は、",count_)
print("[pred==1 and true==1] の数は、",count_OK)
print("[pred==1 and true!=1] の数は、",count_NG)
print("++++++++++++++++++++++++++++++++++++++")
#####################################################################